#include "Interactions.h"
#include <TouchScreen.h>

#define BTN_W 100
#define BTN_H 20
#define SIZE 1

int numVentile = 3;
int Interactions::cocktailv1[] = {3000, 750, 1500};   // Dosierung (Zeit in ms, wie lange jeweiliges Ventil offen ist) ergibt den jeweiligen Cocktail (siehe Arrayname).
int Interactions::cocktailv2[] = {2000, 2000, 4400};
int Interactions::cocktailv3[] = {800, 900, 200};

int Interactions::v1 = 31;   // Ventil 1
int Interactions::v2 = 2;   // Ventil 2
int Interactions::v3 = 3;   // Ventil 3

bool Interactions::screenChange = false;

extern TouchScreen ts;

Elegoo_GFX_Button* Interactions::cocktail1 = new Elegoo_GFX_Button();
Elegoo_GFX_Button* Interactions::cocktail2 = new Elegoo_GFX_Button();
Elegoo_GFX_Button* Interactions::cocktail3 = new Elegoo_GFX_Button();
Elegoo_GFX_Button* Interactions::custom = new Elegoo_GFX_Button();

Elegoo_GFX_Button* Interactions::buttons[] = {
  cocktail1, cocktail2, cocktail3, custom
};

void Interactions::begin() {
  buttons[0]->initButton(tft, (tft->width() - BTN_W) / 2,  120, BTN_W, BTN_H, WHITE, BLACK,  WHITE, "CubaLibre", SIZE);
  buttons[1]->initButton(tft, (tft->width() - BTN_W) / 2, 160, BTN_W, BTN_H, WHITE, BLACK, WHITE, "Florida", SIZE);
  buttons[2]->initButton(tft, (tft->width() - BTN_W) / 2, 200, BTN_W, BTN_H, WHITE, BLACK, WHITE, "Daquiri", SIZE);
  buttons[3]->initButton(tft, (tft->width() - BTN_W) / 2, 280, BTN_W, BTN_H, WHITE, BLACK, WHITE, "Customize", SIZE);
}

void Interactions::mainPage() {
  tft->fillScreen(BLACK);
  tft->setTextColor(WHITE);
  tft->setCursor(20, 30);
  tft->setTextSize(2);
  tft->println("Cocktailauswahl");
  tft->setCursor(20, 50);
  tft->setTextSize(1);
  tft->println("Teste einen fertigen Cocktail");
  tft->setCursor(20, 60);
  tft->println("oder erstelle deinen eigenen!");
  tft->setCursor(20, 70);
  for (int i = 0; i < NumButtons; i++) buttons[i]->drawButton();
}

void Interactions::customPage() {
  tft->fillScreen(BLACK);
  tft->setTextColor(WHITE);
  tft->setCursor(20, 30);
  tft->setTextSize(2);
  tft->println("Eigene Cocktails");
  tft->setCursor(20, 50);
  tft->setTextSize(1);
  tft->println("Kreiere einen eigenen Cocktail");
  tft->setCursor(20, 60);
  tft->println("oder erstelle deinen eigenen!");
  tft->setCursor(20, 70);
  for (int i = 0; i < NumButtons; i++) buttons[i]->drawButton();
}

void Interactions::loop() {

  // https://learn.adafruit.com/arduin-o-phone-arduino-powered-diy-cellphone/arduin-o-phone-sketch
  TSPoint p = ts.getPoint();
  if (p.z > MINPRESSURE && p.z < MAXPRESSURE) {
    p.x = map(p.x, TS_MINX, TS_MAXX, tft->width(), 0);
    p.y = (tft->height() - map(p.y, TS_MINY, TS_MAXY, tft->height(), 0));
    // Serial.print("x="); Serial.print(p.x); Serial.print(" y="); Serial.println(p.y);

    // Ermitteln, welcher Button gedrückt wurde
    for (int i = 0; i < NumButtons; i++) {
      if (buttons[i]->contains(p.x, p.y)) {
        buttons[i]->press(true);
      } else {
        buttons[i]->press(false);
      }
    }

    // Auswerten, welcher Button gedrückt wurde
    for (int i = 0; i < NumButtons; i++) {
      if (buttons[i]->isPressed()) {
        if (buttons[i] == cocktail1) {
          Serial.println("Cocktail 1");
          for(int j = 0; j < numVentile; j++) {
            digitalWrite(30 + j, HIGH);
            delay(cocktailv1[j]);
            Serial.println(cocktailv1[j]);
            digitalWrite(30 + j, LOW); 
          }
        }
        if (buttons[i] == cocktail2) {
          Serial.println("Cocktail 2");
          for(int j = 0; j < numVentile; j++) {
            digitalWrite(30 + j, HIGH);
            delay(cocktailv2[j]);
            Serial.println(cocktailv2[j]);
            digitalWrite(30 + j, LOW); 
          }
        }
        if (buttons[i] == cocktail3) {
          Serial.println("Cocktail 3");
          for(int j = 0; j < numVentile; j++) {
            digitalWrite(30 + j, HIGH);
            delay(cocktailv3[j]);
            Serial.println(cocktailv3[j]);
            digitalWrite(30 + j, LOW); 
          }
        }
        if(buttons[i] == custom) {
          screenChange = true;
        }
      }
    }
  }
}
