#ifndef INTERACTIONS_H
#define INTERACTIONS_H

#define BLACK   0x0000
#define BLUE    0x001F
#define RED     0xF800
#define GREEN   0x07E0
#define CYAN    0x07FF
#define MAGENTA 0xF81F
#define YELLOW  0xFFE0
#define WHITE   0xFFFF

// Touchscreen
#define MINPRESSURE 10
#define MAXPRESSURE 1000
#define TS_MINX 120
#define TS_MAXX 900
#define TS_MINY 70
#define TS_MAXY 920

#define NumButtons 4

#include <Arduino.h>
#include <Elegoo_TFTLCD.h> 

extern Elegoo_TFTLCD* tft;

#define NumMainPageButtons 2

class Interactions {
  private:
    static Elegoo_GFX_Button* cocktail1;
    static Elegoo_GFX_Button* cocktail2;
    static Elegoo_GFX_Button* cocktail3;
    static Elegoo_GFX_Button* custom;
    static Elegoo_GFX_Button* buttons[NumButtons]; 
    
  public:
    static void mainPage();
    static void customPage();
    static void begin();
    static void loop();
    static int v1;   // Ventil 1
    static int v2;   // Ventil 2
    static int v3;   // Ventil 3
    static int cocktailv1[];
    static int cocktailv2[];
    static int cocktailv3[];
    static bool screenChange;
};

#endif
