#include "Interactions.h"
#include <Elegoo_TFTLCD.h>
#include <TouchScreen.h>

#include <SD.h>
#include <SPI.h>

#define BLACK   0x0000
#define BLUE    0x001F
#define RED     0xF800
#define GREEN   0x07E0
#define CYAN    0x07FF
#define MAGENTA 0xF81F
#define YELLOW  0xFFE0
#define WHITE   0xFFFF

#define YP A3  // must be an analog pin, use "An" notation!
#define XM A2  // must be an analog pin, use "An" notation!
#define YM 9   // can be a digital pin
#define XP 8   // can be a digital pin
#define SD_CS    10  // Chip select line for SD card

Elegoo_TFTLCD* tft = new Elegoo_TFTLCD(A3, A2, A1, A0, A4);

#define STMPE_CS 8
TouchScreen ts = TouchScreen(XP, YP, XM, YM, 300);

void setup() {
  
  Serial.begin(250000);
  tft->begin(0x9341);
  tft->setRotation(2);  

  pinMode(Interactions::v1, OUTPUT);
  pinMode(Interactions::v2, OUTPUT);
  pinMode(Interactions::v3, OUTPUT);

  Interactions::begin();
  Interactions::mainPage();

  Serial.println("Gestartet");
  
}

void loop() {
  Interactions::loop();
}
